OGRE: Ogre::MeshManager Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::MeshManager Class Reference
Core » Resources

Handles the management of mesh resources. More...

`#include <OgreMeshManager.h>`

Inheritance diagram for Ogre::MeshManager:
[legend]

## Public Member Functions
| MeshManager ()
| ~MeshManager ()
void | _initialise (void)
| Initialises the manager, only to be called by OGRE internally.
MeshPtr | create (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new mesh.
PatchMeshPtr | createBezierPatch (const String &name, const String &groupName, void *controlPointBuffer, VertexDeclaration *declaration, size_t width, size_t height, size_t uMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, size_t vMaxSubdivisionLevel=PatchSurface::AUTO_LEVEL, PatchSurface::VisibleSide visibleSide=PatchSurface::VS_FRONT, HardwareBuffer::Usage vbUsage=HBU_GPU_ONLY, HardwareBuffer::Usage ibUsage=HBU_CPU_TO_GPU, bool vbUseShadow=true, bool ibUseShadow=true)
| Creates a Bezier patch based on an array of control vertices.
MeshPtr | createCurvedIllusionPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real curvature, int xsegments=1, int ysegments=1, bool normals=true, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, const Quaternion &orientation=Quaternion::IDENTITY, HardwareBuffer::Usage vertexBufferUsage=HBU_GPU_ONLY, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexShadowBuffer=false, bool indexShadowBuffer=false, int ySegmentsToKeep=-1)
| Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox.
MeshPtr | createCurvedPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, Real bow=0.5f, int xsegments=1, int ysegments=1, bool normals=false, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HBU_GPU_ONLY, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexShadowBuffer=false, bool indexShadowBuffer=false)
| Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z.
MeshPtr | createManual (const String &name, const String &groupName, ManualResourceLoader *loader=0)
| Creates a new Mesh specifically for manual definition rather than loading from an object file.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual, ManualResourceLoader *loader, const NameValuePairList *createParams, HardwareBuffer::Usage vertexBufferUsage, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexBufferShadowed=false, bool indexBufferShadowed=false)
| Create a new mesh, or retrieve an existing one with the same name if it already exists.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
MeshPtr | createPlane (const String &name, const String &groupName, const Plane &plane, Real width, Real height, int xsegments=1, int ysegments=1, bool normals=true, unsigned short numTexCoordSets=1, Real uTile=1.0f, Real vTile=1.0f, const Vector3 &upVector=Vector3::UNIT_Y, HardwareBuffer::Usage vertexBufferUsage=HBU_GPU_ONLY, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexShadowBuffer=false, bool indexShadowBuffer=false)
| Creates a basic plane, by default majoring on the x/y axes facing positive Z.
VertexElementType | getBlendWeightsBaseElementType () const
| Gets the base element type used for blend weights in vertex buffers.
Real | getBoundsPaddingFactor (void)
| Gets the factor by which the bounding box of an entity is padded.
MeshPtr | getByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
MeshSerializerListener * | getListener ()
| Gets the listener used to control mesh loading through the serializer.
bool | getPrepareAllMeshesForShadowVolumes (void)
| Retrieves whether all Meshes should prepare themselves for shadow volumes.
MeshPtr | load (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HBU_GPU_ONLY, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexBufferShadowed=false, bool indexBufferShadowed=false)
| Loads a mesh from a file, making it immediately available for use.
MeshPtr | prepare (const String &filename, const String &groupName, HardwareBuffer::Usage vertexBufferUsage=HBU_GPU_ONLY, HardwareBuffer::Usage indexBufferUsage=HBU_GPU_ONLY, bool vertexBufferShadowed=false, bool indexBufferShadowed=false)
| Prepares a mesh for loading from a file.
void | setBlendWeightsBaseElementType (VertexElementType vet)
| sets the base element type used for blend weights in vertex buffers.
void | setBoundsPaddingFactor (Real paddingFactor)
| Sets the factor by which the bounding box of an entity is padded.
void | setListener (MeshSerializerListener *listener)
| Sets the listener used to control mesh loading through the serializer.
void | setPrepareAllMeshesForShadowVolumes (bool enable)
| Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading.
Public Member Functions inherited from Ogre::ResourceManager
| ResourceManager ()
virtual | ~ResourceManager ()
virtual void | _notifyResourceLoaded (Resource *res)
| Notify this manager that a resource which it manages has been loaded.
virtual void | _notifyResourceTouched (Resource *res)
| Notify this manager that a resource which it manages has been 'touched', i.e.
virtual void | _notifyResourceUnloaded (Resource *res)
| Notify this manager that a resource which it manages has been unloaded.
ResourceCreateOrRetrieveResult | createOrRetrieve (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Create a new resource, or retrieve an existing one with the same name if it already exists.
ResourcePtr | createResource (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *createParams=0)
| Creates a new blank resource, but does not immediately load it.
void | destroyAllResourcePools ()
| destroy all pools
void | destroyResourcePool (const String &name)
| Destroy a resource pool.
void | destroyResourcePool (ResourcePool *pool)
| Destroy a resource pool.
virtual ResourcePtr | getByHandle (ResourceHandle handle) const
| Retrieves a pointer to a resource by handle, or null if the resource does not exist.
Real | getLoadingOrder (void) const override
| Gets the loading order for scripts of this type.
size_t | getMemoryBudget (void) const
| Get the limit on the amount of memory this resource handler may use.
size_t | getMemoryUsage (void) const
| Gets the current memory usage, in bytes.
virtual ResourcePtr | getResourceByName (const String &name, const String &groupName=RGN_DEFAULT) const
| Retrieves a pointer to a resource by name, or null if the resource does not exist.
ResourceMapIterator | getResourceIterator (void)
| Returns an iterator over all resources in this manager.
ResourcePool * | getResourcePool (const String &name)
| Create a resource pool, or reuse one that already exists.
const String & | getResourceType (void) const
| Gets a string identifying the type of resource this manager handles.
const StringVector & | getScriptPatterns (void) const override
| Gets the file patterns which should be used to find scripts for this class.
bool | getVerbose (void)
| Gets whether this manager and its resources habitually produce log output.
ResourcePtr | load (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic load method, used to create a Resource specific to this ResourceManager without using one of the specialised 'load' methods (containing per-Resource-type parameters).
void | parseScript (DataStreamPtr &stream, const String &groupName) override
| Parse a script file.
ResourcePtr | prepare (const String &name, const String &group, bool isManual=false, ManualResourceLoader *loader=0, const NameValuePairList *loadParams=0, bool backgroundThread=false)
| Generic prepare method, used to create a Resource specific to this ResourceManager without using one of the specialised 'prepare' methods (containing per-Resource-type parameters).
void | reloadAll (bool reloadableOnly=true)
| Caused all currently loaded resources to be reloaded.
virtual void | reloadAll (Resource::LoadingFlags flags)
| Caused all currently loaded resources to be reloaded.
void | reloadUnreferencedResources (bool reloadableOnly=true)
| Caused all currently loaded but not referenced by any other object resources to be reloaded.
void | remove (const ResourcePtr &r)
| Remove a single resource.
void | remove (const String &name, const String &group=RGN_DEFAULT)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | remove (ResourceHandle handle)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | removeAll (void)
| Removes all resources.
virtual void | removeUnreferencedResources (bool reloadableOnly=true)
| Remove all resources which are not referenced by any other object.
bool | resourceExists (const String &name, const String &group=RGN_DEFAULT) const
| Returns whether the named resource exists in this manager.
bool | resourceExists (ResourceHandle handle) const
| Returns whether a resource with the given handle exists in this manager.
void | setMemoryBudget (size_t bytes)
| Set a limit on the amount of memory this resource handler may use.
void | setVerbose (bool v)
| Sets whether this manager and its resources habitually produce log output.
void | unload (const String &name, const String &group=RGN_DEFAULT)
| Unloads a single resource by name.
void | unload (ResourceHandle handle)
| Unloads a single resource by handle.
void | unloadAll (bool reloadableOnly=true)
| Unloads all resources.
virtual void | unloadAll (Resource::LoadingFlags flags)
| Unloads all resources.
void | unloadUnreferencedResources (bool reloadableOnly=true)
| Unload all resources which are not referenced by any other object.
Public Member Functions inherited from Ogre::ScriptLoader
virtual | ~ScriptLoader ()
Public Member Functions inherited from Ogre::Singleton< MeshManager >
| ~Singleton (void)

## Static Public Member Functions
static bool | getBonesUseObjectSpace ()
| whether the bone matrices are in object space or world space
static MeshManager & | getSingleton (void)
| Get the singleton instance.
static MeshManager * | getSingletonPtr (void)
| Get the singleton instance.
static void | setBonesUseObjectSpace (bool enable)
| Set whether to keep the bone matrices in object space or transform them to world space.
Static Public Member Functions inherited from Ogre::Singleton< MeshManager >
static MeshManager & | getSingleton (void)
| Get the singleton instance.
static MeshManager * | getSingletonPtr (void)
| Get the singleton instance.

## Additional Inherited Members
Public Types inherited from Ogre::ResourceManager
typedef std::pair< ResourcePtr, bool > | ResourceCreateOrRetrieveResult
typedef std::map< ResourceHandle, ResourcePtr > | ResourceHandleMap
typedef std::unordered_map< String, ResourcePtr > | ResourceMap
typedef MapIterator< ResourceHandleMap > | ResourceMapIterator
typedef std::unordered_map< String, ResourceMap > | ResourceWithGroupMap

## Detailed Description

Handles the management of mesh resources.

This class deals with the runtime management of mesh data; like other resource managers it handles the creation of resources (in this case mesh data), working within a fixed memory budget.

Ogre loads model files from it's own proprietary format called .mesh. This is because having a single file format is better for runtime performance, and we also have control over pre-processed data (such as collision boxes, LOD reductions etc).

## Constructor & Destructor Documentation

## ◆ MeshManager()

Ogre::MeshManager::MeshManager | ( |  | ) |

Referenced by getSingleton(), and getSingletonPtr().

## ◆ ~MeshManager()

Ogre::MeshManager::~MeshManager | ( |  | ) |

## Member Function Documentation

## ◆ _initialise()

void Ogre::MeshManager::_initialise | ( | void |  | ) |

Initialises the manager, only to be called by OGRE internally.

## ◆ getByName()

MeshPtr Ogre::MeshManager::getByName | ( | const String & | name,
|  | const String & | groupName = RGN_DEFAULT ) const

Retrieves a pointer to a resource by name, or null if the resource does not exist.

References OGRE_RESOURCE_GROUP_INIT.

## ◆ create()

MeshPtr Ogre::MeshManager::create | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new mesh.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

References Ogre::ResourceManager::createOrRetrieve().

## ◆ createOrRetrieve() [1/2]

ResourceCreateOrRetrieveResult Ogre::MeshManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual,
|  | ManualResourceLoader * | loader,
|  | const NameValuePairList * | createParams,
|  | HardwareBuffer::Usage | vertexBufferUsage,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexBufferShadowed = false,
|  | bool | indexBufferShadowed = false )

Create a new mesh, or retrieve an existing one with the same name if it already exists.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

References Ogre::HBU_GPU_ONLY.

## ◆ prepare()

MeshPtr Ogre::MeshManager::prepare | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexBufferShadowed = false,
|  | bool | indexBufferShadowed = false )

Prepares a mesh for loading from a file.

This does the IO in advance of the call to load().

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

References Ogre::HBU_GPU_ONLY.

## ◆ load()

MeshPtr Ogre::MeshManager::load | ( | const String & | filename,
|  | const String & | groupName,
|  | HardwareBuffer::Usage | vertexBufferUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexBufferShadowed = false,
|  | bool | indexBufferShadowed = false )

Loads a mesh from a file, making it immediately available for use.

This does the IO in advance of the call to load().

Note
  If the model has already been created (prepared or loaded), the existing instance will be returned.

Parameters

  filename | The name of the .mesh file
  groupName | The name of the resource group to assign the mesh to
  vertexBufferUsage | The usage flags with which the vertex buffer(s) will be created
  indexBufferUsage | The usage flags with which the index buffer(s) created for this mesh will be created with.
  vertexBufferShadowed | If true, the vertex buffers will be shadowed by system memory copies for faster read access
  indexBufferShadowed | If true, the index buffers will be shadowed by system memory copies for faster read access

References Ogre::HBU_GPU_ONLY.

## ◆ createManual()

MeshPtr Ogre::MeshManager::createManual | ( | const String & | name,
|  | const String & | groupName,
|  | ManualResourceLoader * | loader = 0 )

Creates a new Mesh specifically for manual definition rather than loading from an object file.

Note that once you've defined your mesh, you must call Mesh::_setBounds in order to define the bounds of your mesh. In previous versions of OGRE could auto-compute that, but OGRE's support of write-only vertex buffers makes this no longer appropriate.

Parameters

  name | The name to give the new mesh
  groupName | The name of the resource group to assign the mesh to
  loader | ManualResourceLoader which will be called to load this mesh when the time comes. It is recommended that you populate this field in order that the mesh can be rebuilt should the need arise

## ◆ createPlane()

MeshPtr Ogre::MeshManager::createPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | int | xsegments = 1,
|  | int | ysegments = 1,
|  | bool | normals = true,
|  | unsigned short | numTexCoordSets = 1,
|  | Real | uTile = 1.0f,
|  | Real | vTile = 1.0f,
|  | const Vector3 & | upVector = Vector3::UNIT_Y,
|  | HardwareBuffer::Usage | vertexBufferUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexShadowBuffer = false,
|  | bool | indexShadowBuffer = false )

Creates a basic plane, by default majoring on the x/y axes facing positive Z.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane texture coordinates.
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

References Ogre::HBU_GPU_ONLY.

## ◆ createCurvedIllusionPlane()

MeshPtr Ogre::MeshManager::createCurvedIllusionPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | curvature,
|  | int | xsegments = 1,
|  | int | ysegments = 1,
|  | bool | normals = true,
|  | unsigned short | numTexCoordSets = 1,
|  | Real | uTile = 1.0f,
|  | Real | vTile = 1.0f,
|  | const Vector3 & | upVector = Vector3::UNIT_Y,
|  | const Quaternion & | orientation = Quaternion::IDENTITY,
|  | HardwareBuffer::Usage | vertexBufferUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexShadowBuffer = false,
|  | bool | indexShadowBuffer = false,
|  | int | ySegmentsToKeep = -1 )

Creates a plane, which because of it's texture coordinates looks like a curved surface, useful for skies in a skybox.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  curvature | The curvature of the plane. Good values are between 2 and 65. Higher values are more curved leading to a smoother effect, lower values are less curved meaning more distortion at the horizons but a better distance effect.
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane.
  orientation | The orientation of the overall sphere that's used to create the illusion
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  ySegmentsToKeep | The number of segments from the top of the dome downwards to keep. -1 keeps all of them. This can save fillrate if you cannot see much of the sky lower down.

References Ogre::HBU_GPU_ONLY, and Ogre::Quaternion::IDENTITY.

## ◆ createCurvedPlane()

MeshPtr Ogre::MeshManager::createCurvedPlane | ( | const String & | name,
|  | const String & | groupName,
|  | const Plane & | plane,
|  | Real | width,
|  | Real | height,
|  | Real | bow = 0.5f,
|  | int | xsegments = 1,
|  | int | ysegments = 1,
|  | bool | normals = false,
|  | unsigned short | numTexCoordSets = 1,
|  | Real | uTile = 1.0f,
|  | Real | vTile = 1.0f,
|  | const Vector3 & | upVector = Vector3::UNIT_Y,
|  | HardwareBuffer::Usage | vertexBufferUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | indexBufferUsage = HBU_GPU_ONLY,
|  | bool | vertexShadowBuffer = false,
|  | bool | indexShadowBuffer = false )

Creates a genuinely curved plane, by default majoring on the x/y axes facing positive Z.

Parameters

  name | The name to give the resulting mesh
  groupName | The name of the resource group to assign the mesh to
  plane | The orientation of the plane and distance from the origin
  width | The width of the plane in world coordinates
  height | The height of the plane in world coordinates
  bow | The amount of 'bow' in the curved plane. (Could also be considered the depth.)
  xsegments | The number of segments to the plane in the x direction
  ysegments | The number of segments to the plane in the y direction
  normals | If true, normals are created perpendicular to the plane
  numTexCoordSets | The number of 2D texture coordinate sets created - by default the corners are created to be the corner of the texture.
  uTile | The number of times the texture should be repeated in the u direction
  vTile | The number of times the texture should be repeated in the v direction
  upVector | The 'Up' direction of the plane.
  vertexBufferUsage | The usage flag with which the vertex buffer for this plane will be created
  indexBufferUsage | The usage flag with which the index buffer for this plane will be created
  vertexShadowBuffer | If this flag is set to true, the vertex buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware
  indexShadowBuffer | If this flag is set to true, the index buffer will be created with a system memory shadow buffer, allowing you to read it back more efficiently than if it is in hardware

References Ogre::HBU_GPU_ONLY.

## ◆ createBezierPatch()

PatchMeshPtr Ogre::MeshManager::createBezierPatch | ( | const String & | name,
|  | const String & | groupName,
|  | void * | controlPointBuffer,
|  | VertexDeclaration * | declaration,
|  | size_t | width,
|  | size_t | height,
|  | size_t | uMaxSubdivisionLevel = PatchSurface::AUTO_LEVEL,
|  | size_t | vMaxSubdivisionLevel = PatchSurface::AUTO_LEVEL,
|  | PatchSurface::VisibleSide | visibleSide = PatchSurface::VS_FRONT,
|  | HardwareBuffer::Usage | vbUsage = HBU_GPU_ONLY,
|  | HardwareBuffer::Usage | ibUsage = HBU_CPU_TO_GPU,
|  | bool | vbUseShadow = true,
|  | bool | ibUseShadow = true )

Creates a Bezier patch based on an array of control vertices.

Parameters

  name | The name to give the newly created mesh.
  groupName | The name of the resource group to assign the mesh to
  controlPointBuffer | A pointer to a buffer containing the vertex data which defines control points of the curves rather than actual vertices. Note that you are expected to provide not just position information, but potentially normals and texture coordinates too. The format of the buffer is defined in the VertexDeclaration parameter
  declaration | VertexDeclaration describing the contents of the buffer. Note this declaration must only draw on buffer source 0!
  width | Specifies the width of the patch in control points. Note this parameter must greater than or equal to 3.
  height | Specifies the height of the patch in control points. Note this parameter must greater than or equal to 3.
  uMaxSubdivisionLevel,vMaxSubdivisionLevel | If you want to manually set the top level of subdivision, do it here, otherwise let the system decide.
  visibleSide | Determines which side of the patch (or both) triangles are generated for.
  vbUsage | Vertex buffer usage flags. Recommend the default since vertex buffer should be static.
  ibUsage | Index buffer usage flags. Recommend the default since index buffer should be dynamic to change levels but not readable.
  vbUseShadow | Flag to determine if a shadow buffer is generated for the vertex buffer. See HardwareBuffer for full details.
  ibUseShadow | Flag to determine if a shadow buffer is generated for the index buffer. See HardwareBuffer for full details.

References Ogre::PatchSurface::AUTO_LEVEL, Ogre::HBU_CPU_TO_GPU, Ogre::HBU_GPU_ONLY, and Ogre::PatchSurface::VS_FRONT.

## ◆ setPrepareAllMeshesForShadowVolumes()

void Ogre::MeshManager::setPrepareAllMeshesForShadowVolumes | ( | bool | enable | ) |

Tells the mesh manager that all future meshes should prepare themselves for shadow volumes on loading.

## ◆ getPrepareAllMeshesForShadowVolumes()

bool Ogre::MeshManager::getPrepareAllMeshesForShadowVolumes | ( | void |  | ) |

Retrieves whether all Meshes should prepare themselves for shadow volumes.

## ◆ getSingleton()

MeshManager & Ogre::MeshManager::getSingleton | ( | void |  | ) |
| static

Get the singleton instance.

References MeshManager().

## ◆ getSingletonPtr()

MeshManager * Ogre::MeshManager::getSingletonPtr | ( | void |  | ) |
| static

Get the singleton instance.

References MeshManager().

## ◆ getBlendWeightsBaseElementType()

VertexElementType Ogre::MeshManager::getBlendWeightsBaseElementType | ( |  | ) | const

Gets the base element type used for blend weights in vertex buffers.

See the remarks below for SetBlendWeightsBaseElementType().

## ◆ setBlendWeightsBaseElementType()

void Ogre::MeshManager::setBlendWeightsBaseElementType | ( | VertexElementType | vet | ) |

sets the base element type used for blend weights in vertex buffers.

This takes effect when meshes are loaded. Default is VET_FLOAT1. Valid values are: VET_UBYTE4_NORM: 8-bit blend weights. Lowest memory cost but may have precision issues. Requires SM2.0+ vertex shader. No software skinning. VET_USHORT2_NORM: 16-bit blend weights. Requires SM2.0+ vertex shader. No software skinning. VET_FLOAT1: 32-bit blend weights. Highest memory cost. Supports hardware and software skinning.

## ◆ setBonesUseObjectSpace()

void Ogre::MeshManager::setBonesUseObjectSpace | ( | bool | enable | ) |
| inlinestatic

Set whether to keep the bone matrices in object space or transform them to world space.

Transforming to world space happens on the CPU and is the legacy behavior. Using object space bones is more efficient as it allows to do the transformation in the vertex shader.

## ◆ getBonesUseObjectSpace()

bool Ogre::MeshManager::getBonesUseObjectSpace | ( |  | ) |
| inlinestatic

whether the bone matrices are in object space or world space

## ◆ getBoundsPaddingFactor()

Real Ogre::MeshManager::getBoundsPaddingFactor | ( | void |  | ) |

Gets the factor by which the bounding box of an entity is padded.

Default is 0.01

## ◆ setBoundsPaddingFactor()

void Ogre::MeshManager::setBoundsPaddingFactor | ( | Real | paddingFactor | ) |

Sets the factor by which the bounding box of an entity is padded.

## ◆ setListener()

void Ogre::MeshManager::setListener | ( | MeshSerializerListener * | listener | ) |

Sets the listener used to control mesh loading through the serializer.

## ◆ getListener()

MeshSerializerListener * Ogre::MeshManager::getListener | ( |  | ) |

Gets the listener used to control mesh loading through the serializer.

## ◆ createOrRetrieve() [2/2]

ResourceCreateOrRetrieveResult Ogre::ResourceManager::createOrRetrieve | ( | const String & | name,
|  | const String & | group,
|  | bool | isManual = false,
|  | ManualResourceLoader * | loader = 0,
|  | const NameValuePairList * | createParams = 0 )

Create a new resource, or retrieve an existing one with the same name if it already exists.

This method performs the same task as calling getByName() followed by create() if that returns null. The advantage is that it does it in one call so there are no race conditions if using multiple threads that could cause getByName() to return null, but create() to fail because another thread created a resource in between.

Parameters

  name | The unique name of the Resource
  group | The name of the resource group to attach this new resource to
  isManual | Is this resource manually loaded? If so, you should really populate the loader parameter in order that the load process can call the loader back when loading is required.
  loader | Pointer to a ManualLoader implementation which will be called when the Resource wishes to load (should be supplied if you set isManual to true). You can in fact leave this parameter null if you wish, but the Resource will never be able to reload if anything ever causes it to unload. Therefore provision of a proper ManualLoader instance is strongly recommended.
  createParams | If any parameters are required to create an instance, they should be supplied here as name / value pairs

Returns
  A pair, the first element being the pointer, and the second being an indicator specifying whether the resource was newly created.

The documentation for this class was generated from the following file:

- OgreMeshManager.h